package com.hfkj.dao;

import com.hfkj.entity.BsOrderSettleLedger;
import com.hfkj.entity.BsOrderSettleLedgerExample.Criteria;
import com.hfkj.entity.BsOrderSettleLedgerExample.Criterion;
import com.hfkj.entity.BsOrderSettleLedgerExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderSettleLedgerSqlProvider {

    public String countByExample(BsOrderSettleLedgerExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_settle_ledger");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderSettleLedgerExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_settle_ledger");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderSettleLedger record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_settle_ledger");
        
        if (record.getOrderSettleId() != null) {
            sql.VALUES("order_settle_id", "#{orderSettleId,jdbcType=BIGINT}");
        }
        
        if (record.getRatio() != null) {
            sql.VALUES("ratio", "#{ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getSharingAmount() != null) {
            sql.VALUES("sharing_amount", "#{sharingAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverMerNo() != null) {
            sql.VALUES("receiver_mer_no", "#{receiverMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverMerName() != null) {
            sql.VALUES("receiver_mer_name", "#{receiverMerName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAmount() != null) {
            sql.VALUES("receiver_amount", "#{receiverAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.VALUES("profit_sharing_time", "#{profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderSettleLedgerExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_settle_id");
        sql.SELECT("ratio");
        sql.SELECT("sharing_amount");
        sql.SELECT("receiver_mer_no");
        sql.SELECT("receiver_mer_name");
        sql.SELECT("receiver_amount");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("profit_sharing_time");
        sql.SELECT("finish_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_settle_ledger");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderSettleLedger record = (BsOrderSettleLedger) parameter.get("record");
        BsOrderSettleLedgerExample example = (BsOrderSettleLedgerExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle_ledger");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderSettleId() != null) {
            sql.SET("order_settle_id = #{record.orderSettleId,jdbcType=BIGINT}");
        }
        
        if (record.getRatio() != null) {
            sql.SET("ratio = #{record.ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getSharingAmount() != null) {
            sql.SET("sharing_amount = #{record.sharingAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverMerNo() != null) {
            sql.SET("receiver_mer_no = #{record.receiverMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverMerName() != null) {
            sql.SET("receiver_mer_name = #{record.receiverMerName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAmount() != null) {
            sql.SET("receiver_amount = #{record.receiverAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.SET("profit_sharing_time = #{record.profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle_ledger");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_settle_id = #{record.orderSettleId,jdbcType=BIGINT}");
        sql.SET("ratio = #{record.ratio,jdbcType=DECIMAL}");
        sql.SET("sharing_amount = #{record.sharingAmount,jdbcType=DECIMAL}");
        sql.SET("receiver_mer_no = #{record.receiverMerNo,jdbcType=VARCHAR}");
        sql.SET("receiver_mer_name = #{record.receiverMerName,jdbcType=VARCHAR}");
        sql.SET("receiver_amount = #{record.receiverAmount,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("profit_sharing_time = #{record.profitSharingTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderSettleLedgerExample example = (BsOrderSettleLedgerExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderSettleLedger record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle_ledger");
        
        if (record.getOrderSettleId() != null) {
            sql.SET("order_settle_id = #{orderSettleId,jdbcType=BIGINT}");
        }
        
        if (record.getRatio() != null) {
            sql.SET("ratio = #{ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getSharingAmount() != null) {
            sql.SET("sharing_amount = #{sharingAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverMerNo() != null) {
            sql.SET("receiver_mer_no = #{receiverMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverMerName() != null) {
            sql.SET("receiver_mer_name = #{receiverMerName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAmount() != null) {
            sql.SET("receiver_amount = #{receiverAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.SET("profit_sharing_time = #{profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderSettleLedgerExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}